<script setup lang="ts">
import { onClickOutside } from '@vueuse/core'
import _ from 'lodash'
import { usePollStore } from '~/store/poll'
import type { PollType } from '~/store/poll'

interface CompanyPoll {
  data: PollType
  id: string
}

const {
  data,
  id,
} = defineProps<CompanyPoll>()
const poll = usePollStore()

const release = () => poll.releasePoll(id)

// Popup Toggle
const popup = ref(false)
const popupEl = ref(null)
onClickOutside(popupEl, () => (popup.value = false))

const edit = () => {
  popup.value = false
  poll.startEditPoll(id)
}

// Delete
let startDelete = $ref(false)
const startDeleting = () => {
  startDelete = true
  popup.value = false
}
const deleteP = () => {
  startDelete = false
  poll.deletePoll(id)
}

// stop Poll
const stopP = () => {
  poll.stopPoll(id)
}

const showResult = $ref(false)
</script>

<template>
  <div class="text-lg border dark:border-white p-2 mt-[-1px]">
    <div class="flex flex-row">
      <p class="flex-1 break-all pr-2">
        アンケート: {{ data.question }}
      </p>
      <div v-if="!data.released" ref="popupEl" class="flex gap-2 flex-row items-center">
        <button class="bg-blue-500 px-4 py-1 rounded text-white" @click="release">
          送信
        </button>
        <div class="px-2 pb-2 pt-1 cursor-pointer relative">
          <div class="i-bi:three-dots-vertical" @click="popup = true" />
          <div v-if="popup" class="absolute top-full right-0 border bg-white dark:bg-neutral-900">
            <button class="p-2 px-4 hover:bg-gray-300 w-full whitespace-nowrap" @click="edit">
              編集する
            </button>
            <button class="p-2 px-4 hover:bg-gray-300 whitespace-nowrap" @click="startDeleting">
              削除する
            </button>
          </div>
        </div>
      </div>
    </div>
    <div v-if="data.released">
      <div class="flex justify-between text-base">
        <button class="flex items-center" @click="showResult = !showResult">
          <div class="w-6 h-6" :class="showResult ? 'i-entypo:triangle-up' : 'i-entypo:triangle-down'" />
          <span class="underline">回答結果</span>
        </button>
        <button v-if="data.stop" class="px-4 py-1 rounded text-red-600 dark:text-red-400">
          回答締め切り済
        </button>
        <button v-else class="border border-blue-500 text-blue-500 bg-white px-4 py-1 rounded" @click="stopP">
          回答を締め切り
        </button>
      </div>
      <MChart v-if="showResult" title="Result" :labels="_.map(data.Answer, a => a.answer)" :data="_.map(data.Answer, i => i.noOfAnswer)" />
    </div>
    <AWarningModel v-if="startDelete" text="削除してよろしでしょうか?" @accept="deleteP" @close="startDelete = false" />
  </div>
</template>

<style scoped></style>
